#include "field_data.hxx"

#include <rtl/ustrbuf.hxx>
using rtl::OUStringBuffer;


USHORT FieldData::IsA()
{
	return FIELD_DATA_ITEM_ID;
}

void FieldData::Paint(const Point& rPos, SvLBox& rOutDev,
		      USHORT nViewDataEntryFlags,
		      SvLBoxEntry* pEntry)
{
}

void FieldData::InitViewData( SvLBox* pView, SvLBoxEntry* pEntry, SvViewDataItem* pViewData)
{
    	if( !pViewData )
		pViewData = pView->GetViewDataItem( pEntry, this );
	pViewData->aSize = Size(0, 0);
}

void FieldData::Clone(SvLBoxItem* pSource )
{
	FieldData* f = static_cast<FieldData*>(pSource);
	interface = f->interface;
	field_name = f->field_name;
}

SvLBoxItem* FieldData::Create() const
{
	return new FieldData(OUString(), OUString(), 0, FALSE);
}

rtl::OUString FieldData::GetURL() const
{
	OUStringBuffer s;
	s.append(OUString(RTL_CONSTASCII_USTRINGPARAM("http://api.openoffice.org/docs/common/ref")));
	unsigned int index = 0;
	int next_index;
	while (true) {
		next_index = interface.indexOf('.', index);
		s.append(sal_Unicode('/'));
		unsigned int count;
		if (next_index != -1) {
			count = next_index - index;
		} else {
			count = interface.getLength()  - index;
		}
		s.append(interface.copy(index, count));
		if (next_index == -1) {
			break;
		}
		index = next_index + 1;
		if (index >= interface.getLength()) {
			break;
		}
	}
	s.append(OUString(RTL_CONSTASCII_USTRINGPARAM(".html")));
	if (field_name.getLength() > 0) {
	    s.append(sal_Unicode('#'));
	    s.append(field_name);
	}
	return s.makeStringAndClear();
}
